## org.apache.lucene.search
Class ReqExclScorer

    java.lang.Object
      org.apache.lucene.search.DocIdSetIterator
          org.apache.lucene.search.Scorer
              org.apache.lucene.search.ReqExclScorer

    public class ReqExclScorer

extends Scorer

A Scorer for queries with a required subscorer and an excluding (prohibited) subscorer.
This `Scorer` implements `DocIdSetIterator.skipTo(int)`, and it uses the skipTo() on the given scorers.

Constructor Summary
`ReqExclScorer(Scorer reqScorer, Scorer exclScorer)` Construct a `ReqExclScorer`.

Method Summary
`int` `doc()` Returns the current document number.
`Explanation` `explain(int doc)` Returns an explanation of the score for a document.
`boolean` `next()` Moves to the next docId in the set.
`float` `score()` Returns the score of the current document matching the query.
`boolean` `skipTo(int target)` Skips to the first match beyond the current whose document number is greater than or equal to a given target.

Methods inherited from class org.apache.lucene.search.Scorer
`getSimilarity, score, score`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ReqExclScorer

    public ReqExclScorer(Scorer reqScorer,
                         Scorer exclScorer)

  Construct a `ReqExclScorer`.

  Parameters:
    `reqScorer` - The scorer that must match, except where
    `exclScorer` - indicates exclusion.

Method Detail

### next

    public boolean next()
                 throws IOException

  Description copied from class: `DocIdSetIterator`
  Moves to the next docId in the set. Returns true, iff there is such a docId.

  Specified by:
    `next` in class `DocIdSetIterator`
  Throws:
    `IOException`

### doc

    public int doc()

  Description copied from class: `DocIdSetIterator`
  Returns the current document number.

  This is invalid until `DocIdSetIterator.next()` is called for the first time.

  Specified by:
    `doc` in class `DocIdSetIterator`

### score

    public float score()
                throws IOException

  Returns the score of the current document matching the query. Initially invalid, until `next()` is called the first time.

  Specified by:
    `score` in class `Scorer`
  Returns:
    The score of the required scorer.
  Throws:
    `IOException`

### skipTo

    public boolean skipTo(int target)
                   throws IOException

  Skips to the first match beyond the current whose document number is greater than or equal to a given target.
  When this method is used the `explain(int)` method should not be used.

  Specified by:
    `skipTo` in class `DocIdSetIterator`
  Parameters:
    `target` - The target document number.
  Returns:
    true iff there is such a match.
  Throws:
    `IOException`

### explain

    public Explanation explain(int doc)
                        throws IOException

  Description copied from class: `Scorer`
  Returns an explanation of the score for a document.
  When this method is used, the `DocIdSetIterator.next()`, `DocIdSetIterator.skipTo(int)` and `Scorer.score(HitCollector)` methods should not be used.

  Specified by:
    `explain` in class `Scorer`
  Parameters:
    `doc` - The document number for the explanation.
  Throws:
    `IOException`

Copyright © 2000-2009 Apache Software Foundation. All Rights Reserved.